// 发音人个数
var mSpeakerCount = 0;

// 每页显示的发音人个数，必须为奇数
var SLIDES_PERVIEW = 5;
// 当前显示的是发音人的下标
var mCurSpeakerIndex = -1000;
// 旧的mIconSwiper的active 项的下标
var mOldIconActiveIndex = -1000;
// 旧的mImageSwiper的active 项的下标
var mOldImageActiveIndex = -1000;
// tts合成文本的长度
var mTextMaxLength = 28;
// 下载进度条的最大高度
var mProgressBarHeight = 0;
// 下载进度，0-1
var mDownProgress = 0;
// 当前被选择的发音人的名字
var mSpeakerSelectedName;
// 是否是mImageSwiper被触摸
var isImageSwiperMove = false;
// 屏幕宽度
var mScreenWidth;



/**   发布或上线时需要修改以下变量  其他要修改的地方请查找关键字 HTTP_PREFIX  **/

//本地assest下的版本获取图片需要用到 ，上线版本需要屏蔽
var HTTP_PREFIX = "http://iss.openspeech.cn/speech/html/speakersetting_1/";
// 本地assest版本
var PATH_PREFIX = "";
// 上线版本需要加上文件夹名字 speakersetting_ + ver
//var PATH_PREFIX = "speakersetting_1/";



var mImage_path_prefix = PATH_PREFIX+"img/";
// 发音人json数据的路径
var mJsonPath = PATH_PREFIX+"data/speaker_data.txt";
// 图片存放的路径
var mImage_path;
// 惯性定时器
var mInertiaTimeOut;

// 客户端屏幕密度系数
var mDensity = 1;

// 图标滑动对象
var mIconSwiper;
// 图片滑动对象
var mImageSwiper;

// 分辨率
var RESOLUTION_480 = 480;
var RESOLUTION_720 = 720;
var RESOLUTION_1080 = 1080;

// 滑动方向
var DIRECTION_NEXT = "next";

// 更新图片的模式
var UPDATW_MODEL_LEFT = "update_left";
var UPDATW_MODEL_ALL = "update_all";
var UPDATW_MODEL_RIGHT = "update_right";

// 下载状态
var NOT_DOWN   = 1001;
var DOWNING    = 1002;
var HAS_DOWN   = 1003;
// 当前发音人的下载状态
var mCurDownState = NOT_DOWN;

/*1003: js计算webview高度*/
var JS_CALL_WEBVIEW_HEIGHT = 1003;
/*1007:获取手机屏幕密度*/
var JS_CALL_PHONE_DENSITY= 1007;
/*1008:获取手机屏幕宽度*/
var JS_CALL_PHONE_WIDTH= 1008;
/*1101:网页html和css加载完成*/
var JS_CALL_CSS_FINISH= 1102;
/*2201:发音人下载*/
var JS_CALL_SPEAKER_DOWN= 2201;
/*2202:发音人试听*/
var JS_CALL_SPEAKER_LISTENING= 2202;
/*2203:发音人查看*/
var JS_CALL_SPEAKER_SEE= 2203;
/*2204:发音人选择*/
var JS_CALL_SPEAKER_SELECT= 2204;
/*2205:发音人分享*/
var JS_CALL_SPEAKER_SHARE= 2205;
/*2206:获取选择的发音人*/
var JS_CALL_GET_SPEAKERSELECTED= 2206;
/*2207:获取发音人下载状态*/
var JS_CALL_SPEAKER_DOWN_STATE= 2207;

// log开关，上线版本需关闭，测试版本可以打开
var mShowLog = false;
function consoleLog(logString)
{
	if(mShowLog)
	{
		console.log(logString);
	}
}

// 初始化方法
$(function() {

	initData();
	
	// 调整界面
	adapterLayout();
	
		
	mImageSwiper = $('.viewpager-container').swiper({
		loop:true,
		queueEndCallbacks: true,
		onTouchStart: function(swipe) {
            consoleLog("mImageSwiper onTouchStart: activeIndex="+ swipe.activeIndex);
        },
		onSlideClick: function(swipe) {	
			consoleLog("mImageSwiper onSlideClick: activeIndex="+swipe.activeIndex);
		},
		onSlideChangeStart: function(swipe, direction) {
            consoleLog("mImageSwiper onSlideChangeStart: activeIndex="+swipe.activeIndex + " direction="+direction);
									
			isImageSwiperMove = true;
			if(mOldImageActiveIndex !== swipe.activeIndex)
			{
				var index = mCurSpeakerIndex;						
				if(direction === DIRECTION_NEXT)
				{
					//mIconSwiper.swipeToWhenLoop(index + 1 - Math.floor(SLIDES_PERVIEW / 2), 5);
					index = (index + 1) % mSpeakerCount;
					updateImageSwiper(index,UPDATW_MODEL_RIGHT); 
				}
				else
				{
					//mIconSwiper.swipeToWhenLoop(index - 1 - Math.floor(SLIDES_PERVIEW / 2), 5);
					index = (index - 1 + mSpeakerCount) % mSpeakerCount;
					updateImageSwiper(index,UPDATW_MODEL_LEFT);
				}				
				
				mOldImageActiveIndex = swipe.activeIndex;
			}
			
        },	
        onSlideChangeEnd: function(swipe, direction) {
			
			consoleLog("mImageSwiper onSlideChangeEnd: activeIndex="+ swipe.activeIndex + " direction="+direction);
			
			swipeIconWhenLoop(mCurSpeakerIndex - Math.floor(SLIDES_PERVIEW / 2));
			// 滑动停止才去更新其他布局界面	
			updateOtherLayout();
			isImageSwiperMove = false;

        },
	});
	
    mIconSwiper = $('.thumbs-container').swiper({
        loop: true,
        slidesPerView: SLIDES_PERVIEW,
        freeMode: true,
        freeModeFluid: true,
        calculateHeight: true,
		queueEndCallbacks: true,
        onSlideClick: function(swipe) {
            clearTimeout(mInertiaTimeOut);

            var offsetIndex = Math.floor(SLIDES_PERVIEW / 2);
            var swipeIndex = swipe.clickedSlideIndex - (swipe.loopedSlides || 0) - offsetIndex;
            consoleLog("mIconSwiper onSlideClick:"+swipeIndex);
            swipeIconWhenLoop(swipeIndex);
        },
        onSlideChangeStart: function(swipe, direction) {
            consoleLog("mIconSwiper onSlideChangeStart:"+ swipe.activeLoopIndex);
        },
        onSlideChangeEnd: function(swipe, direction) {
			
			consoleLog("mIconSwiper onSlideChangeEnd:"+swipe.activeLoopIndex);
														
			var index = (swipe.activeLoopIndex + Math.floor(SLIDES_PERVIEW / 2)) % mSpeakerCount;
			//setTimeout("updateUi(index);", 20);	
			updateUi(index,UPDATW_MODEL_ALL);
        },
        onTouchStart: function(swipe) {
            consoleLog("mIconSwiper onTouchStart:"+swipe.activeLoopIndex);
            clearTimeout(mInertiaTimeOut);
        },
        onTouchEnd: function(swipe) {
            consoleLog("mIconSwiper onTouchEnd getInertiaDuration:"+ swipe.getInertiaDuration());
            mInertiaTimeOut = setTimeout("inertiaAction();",swipe.getInertiaDuration());

        },
        onSlideReset: function(swipe) {
            consoleLog("mIconSwiper onSlideReset:"+ swipe.activeLoopIndex);
        },
		onFirstInit: function(swipe) {
            consoleLog("mIconSwiper onFirstInit:");
			
			// 根据屏幕宽度设置icon的图片
			setIconImage();
        },
    });
	
	// 获取选择的发音人
	mSpeakerSelectedName = JSHandler.JSCall(JS_CALL_GET_SPEAKERSELECTED,null);
	
	// 初始化显示的发音人图片为第 0 张
	mIconSwiper.swipeTo(0 - Math.floor(SLIDES_PERVIEW / 2), 5, true);
	
	// 告知客户端html、css加载完成
	JSHandler.JSCall(JS_CALL_CSS_FINISH,null);
})

// 初始化一些数据
function initData()
{
	//  发现在一台pad上直接用screen.availWidth获取不准确，故从客户端获取
	mScreenWidth = parseInt(JSHandler.JSCall(JS_CALL_PHONE_WIDTH,null));
	
	// 获取不同分辨率的图片前缀
	if(mScreenWidth >= RESOLUTION_1080)
	{
		mImage_path = mImage_path_prefix + RESOLUTION_480 + "/";
	}
	else if(mScreenWidth >= RESOLUTION_720)
	{
		mImage_path = mImage_path_prefix + RESOLUTION_480 + "/";
	}
	else
	{
		mImage_path = mImage_path_prefix + RESOLUTION_480 + "/";
	}
	
	mSpeakerCount = createSpeaker(mJsonPath);
}

// 按照客户端的显示界面大小来调整界面
function adapterLayout() {
	
	// 测试用，对应480*800
	//var availHeight = 462;
	mDensity = parseFloat(JSHandler.JSCall(JS_CALL_PHONE_DENSITY,null));
    var availHeight = Math.floor(parseInt(JSHandler.JSCall(JS_CALL_WEBVIEW_HEIGHT,null)) / mDensity);
	
	// 上中下的高度比，加起来等于1
	var upHeight = Math.ceil(availHeight * 0.686);
	var mediumHeight = Math.floor(availHeight * 0.141);
	var downHeight = availHeight - upHeight - mediumHeight;
	
	
	// 调节上中下的高度
	$('.viewpager-container').height(upHeight);
	$('.viewpager-container .swiper-slide').height(upHeight);
	$('.speaker_image').height(upHeight);
			
	$('.middle_layout').height(mediumHeight);
	
	$('.thumbs-container').height(downHeight);
	$('.thumbs-container .swiper-slide').height(downHeight);
	$('.speaker_icon').height(downHeight);
	$('.icon').height(downHeight);
	$('.opacity_layer').height(downHeight);	
	
	// 合成文本
	$('.tts_text').height($('.text_layout').height() * 0.8 - 5*2);
	$('.tts_text').width($('.text_layout').width() * 0.95 - 5*2);	
	$('.tts_text').css('margin-top',($('.text_layout').height() - $('.tts_text').height() - 5*2)/2);
	$('.tts_text').css('margin-left',($('.text_layout').width() - $('.tts_text').width() - 5*2)/2);
	
	// 试听按钮
	$('.listen_button').width(59 * getPictureRate(RESOLUTION_480));
	$('.listen_button').height(53 * getPictureRate(RESOLUTION_480));
	$('.listen_button').css('margin-top',($('.text_layout').height() - $('.listen_button').height())/2);
	$('.listen_button').css('margin-left',($('.text_layout').width() - $('.listen_button').width())/2);	
	$('.listen_button').attr('src',mImage_path + $('.listen_button').attr('name'));
	
	$('.rotate_button').width(56 * getPictureRate(RESOLUTION_480));
	$('.rotate_button').height(56 * getPictureRate(RESOLUTION_480));
	$('.rotate_button').css('margin-top',($('.download_layout').height() - $('.rotate_button').height())/2);
	$('.rotate_button').css('margin-left',($('.download_layout').width() - $('.rotate_button').width())/2);
	$('.rotate_button').attr('src',mImage_path + $('.rotate_button').attr('name'));
	
	$('.rotate_button').hide();
	$('.progress_value').hide();
}

function setIconImage()
{
	// 设置icon的图片
	$.each($('.speaker_icon'),function(index,slide)
	{
		var icon = $(slide).children('.icon');
		icon.attr('src',mImage_path + icon.attr('name'));
	});
}

// 设置tts 合成文本,多余的文字用 “...” 表
function setTtsText(tts_string)
{
//	if(tts_string.length > mTextMaxLength)
//	{
//		tts_string = tts_string.substr(0,mTextMaxLength - 3) + "...";
//	}
	$('.tts_text').text(tts_string);
}


// 惯性运动
function inertiaAction() {
    var swipeIndex = mIconSwiper.activeIndex - (mIconSwiper.loopedSlides || 0);
    consoleLog("inertiaAction: swipeIndex="+swipeIndex);
    var swipeSuccess = mIconSwiper.swipeTo(swipeIndex, 150, true);
	if(!swipeSuccess)
	{
		var index = (mIconSwiper.activeLoopIndex + Math.floor(SLIDES_PERVIEW / 2)) % mSpeakerCount;	
		updateUi(index,UPDATW_MODEL_ALL);
	}
}

// 滑动mIconSwiper到desIndex， 解决在某些手机上调用swipeToWhenLoop无效的问题
function swipeIconWhenLoop(desIndex)
{
	consoleLog("swipeIconWhenLoop: desIndex="+desIndex+" activeLoopIndex="+mIconSwiper.activeLoopIndex);
	// 目前的activeLoopIndex
	var activeLoopIndex = mIconSwiper.activeLoopIndex;
	desIndex = (desIndex + mSpeakerCount) %mSpeakerCount;
	// 在当前Active项的前边
	if(desIndex === (activeLoopIndex - 1 + mSpeakerCount) % mSpeakerCount)
	{
		consoleLog("swipeIconWhenLoop: prev");
		return mIconSwiper.swipePrev();
	}
	// 在当前Active项的后边
	else if(desIndex === (activeLoopIndex + 1) % mSpeakerCount)
	{
		consoleLog("swipeIconWhenLoop: next");
		return mIconSwiper.swipeNext();
	}
	else
	{
		return mIconSwiper.swipeToWhenLoop(desIndex, 200);
	}
}
// 更新界面
function updateUi(index,update_model) {	
	
	var needUpdate = updateImageSwiper(index,update_model);
	
    if(needUpdate) 
	{
		updateOtherLayout();
    }
}

// 更新界面上半部分的大图滑块
function updateImageSwiper(index,update_model)
{
	consoleLog("updateImageSwiper: index="+index+" mCurSpeakerIndex="+mCurSpeakerIndex);
	
    if(mCurSpeakerIndex !== index) {
		
		// 记录当前发音人的下标
        mCurSpeakerIndex = index;
		
		var curImageSwiperIndex = mImageSwiper.activeIndex;
		speakerSwitch(mCurSpeakerIndex,update_model,curImageSwiperIndex);
		return true;
    }
	return false;
}

// 更新其他布局，包括中间布局和底部的icon滑块
function updateOtherLayout()
{
	consoleLog("updateOtherLayout: mOldIconActiveIndex="+mOldIconActiveIndex+" mIconSwiper.activeIndex="+mIconSwiper.activeIndex);
	// 以mOldIconActiveIndex来判断是否需要更新
	if(mOldIconActiveIndex !== mIconSwiper.activeIndex)
	{
		
		// 设置半透明的层
		resetOpacity((mOldIconActiveIndex + Math.floor(SLIDES_PERVIEW / 2)) % mIconSwiper.slides.length
					 ,(mIconSwiper.activeIndex + Math.floor(SLIDES_PERVIEW / 2)) % mIconSwiper.slides.length);
		mOldIconActiveIndex = mIconSwiper.activeIndex;
		
		// 回调告诉客户端发音人已经切到下一个
		speakerSee();
		
		var speaker = getSpeakerByIndex(mCurSpeakerIndex);		
		// 更新合成文本
		setTtsText(speaker.tts_text);	
		// 更新下载按钮状态
		updateDownLoadButtonState();
	}
}

var mImageIndexArray = [[2,4],[0,2],[1,3],[2,4],[0,2]];
// 切到下一个发音人，并更新发音人信息
function speakerSwitch(speakerIndex,update_model,curImageSwiperIndex){
	consoleLog("speakerSwitch: update_model="+update_model+" curImageSwiperIndex="+curImageSwiperIndex);
	
	var curImageIndex = curImageSwiperIndex;
	
	var leftImageIndex;
	var rightImageIndex;
	
	var leftDownState;
	var rightDownState;
	
	var speaker;
	var params;
	
	// 更新当前发音人信息
	speaker = getSpeakerByIndex(speakerIndex);
	params = TAG_NAME+"="+speaker.name;
	// 记录当前发音人的下载状态
	mCurDownState = parseInt(JSHandler.JSCall(JS_CALL_SPEAKER_DOWN_STATE,params));
	consoleLog("speakerSwitch:name="+speaker.name+" mCurDownState="+mCurDownState+"  curImageIndex="+curImageIndex);		
	updateSpeakerInfo(speaker, mCurDownState, curImageIndex);
	
	if(update_model === UPDATW_MODEL_LEFT)
	{
		// 更新左边发音人信息
		speaker = getSpeakerByIndex(speakerIndex - 1);
		params = TAG_NAME+"="+speaker.name;
		leftDownState = parseInt(JSHandler.JSCall(JS_CALL_SPEAKER_DOWN_STATE,params));		
		leftImageIndex = mImageIndexArray[curImageIndex][0];
		
		consoleLog("speakerSwitch:name="+speaker.name+" leftDownState="+leftDownState+"  leftImageIndex="+leftImageIndex);
		updateSpeakerInfo(speaker, leftDownState, leftImageIndex);
	}
	else if(update_model === UPDATW_MODEL_RIGHT)
	{
		// 更新右边发音人信息
		speaker = getSpeakerByIndex(speakerIndex + 1);
		params = TAG_NAME+"="+speaker.name;
		rightDownState = parseInt(JSHandler.JSCall(JS_CALL_SPEAKER_DOWN_STATE,params));		
		rightImageIndex = mImageIndexArray[curImageIndex][1];
		
		consoleLog("speakerSwitch:name="+speaker.name+" rightDownState="+rightDownState+"  rightImageIndex="+rightImageIndex);
		updateSpeakerInfo(speaker, rightDownState, rightImageIndex);
	}
	// 更新左、右的发音人图片状态
	else
	{
		speaker = getSpeakerByIndex(speakerIndex - 1);
		params = TAG_NAME+"="+speaker.name;
		leftDownState = parseInt(JSHandler.JSCall(JS_CALL_SPEAKER_DOWN_STATE,params));			
		leftImageIndex = mImageIndexArray[curImageIndex][0];		
		consoleLog("speakerSwitch:name="+speaker.name+" leftDownState="+leftDownState+"  leftImageIndex="+leftImageIndex);
		updateSpeakerInfo(speaker, leftDownState, leftImageIndex);
		
		speaker = getSpeakerByIndex(speakerIndex + 1);
		params = TAG_NAME+"="+speaker.name;
		rightDownState = parseInt(JSHandler.JSCall(JS_CALL_SPEAKER_DOWN_STATE,params));		
		rightImageIndex = mImageIndexArray[curImageIndex][1];		
		consoleLog("speakerSwitch:name="+speaker.name+" rightDownState="+rightDownState+"  rightImageIndex="+rightImageIndex);
		updateSpeakerInfo(speaker, rightDownState, rightImageIndex);
		
	}
}

function getAnotherSpeakerImageDiv(index)
{	
	// mImageSwiper 里只加载了3个swiper-slide，并且一页只显示1个
	var anotherIndex = getAnotherIndex(3,1,index);
	return $('.speaker_image').eq(anotherIndex);
}

/**
*** 根据Swiper库总结出的计算方法，根据slideItem的下标获取复制者或者被复制者的下标
**/
function getAnotherIndex(count, countPerView, index)
{
	var length;
	if(count > 2*countPerView)
	{
		length = count + 2*countPerView - 1;
	}
	else
	{
		length = count + countPerView - 1;
	}
	
	if((index + count) <=  length)
	{
		return index + count;
	}
	else if((index - count) >=  0)
	{
		return index - count;
	}
	else
	{
		return index;
	}
}

function updateSpeakerInfo(speaker, downState, imageSwiperIndex)
{	

	var speakerImageDiv_One = $('.speaker_image').eq(imageSwiperIndex);
	var speakerImageDiv_Another = getAnotherSpeakerImageDiv(imageSwiperIndex);
	
    var accentDiv_One = speakerImageDiv_One.children('.accent');
	var tipDiv_One = speakerImageDiv_One.children('.speaker_tip');
	var bgImg_One = speakerImageDiv_One.children('.speaker_bg');
	
	var accentDiv_Another = speakerImageDiv_Another.children('.accent');
	var tipDiv_Another = speakerImageDiv_Another.children('.speaker_tip');
	var bgImg_Another = speakerImageDiv_Another.children('.speaker_bg');
	
	// 更新口音
	accentDiv_One.text(speaker.accent_cn);
	accentDiv_Another.text(speaker.accent_cn);
	
	// assest 版本
	if(speaker.name === SPEAKER_XIAOYAN)
	{
		bgImg_One.attr("src", mImage_path_prefix + speaker.bg_name);
		bgImg_Another.attr("src", mImage_path_prefix + speaker.bg_name);
	}
	else
	{
		bgImg_One.attr("src", HTTP_PREFIX+mImage_path_prefix + speaker.bg_name);
	    bgImg_Another.attr("src", HTTP_PREFIX+mImage_path_prefix + speaker.bg_name);
	}
	
	// 上线版本
	//bgImg_One.attr("src", mImage_path_prefix + speaker.bg_name);
	//bgImg_Another.attr("src", mImage_path_prefix + speaker.bg_name);
	
	updateNikeName(speaker, imageSwiperIndex);
	
	// 是否显示提示语
	if(isEnglishSpeaker(speaker.language))
	{
		tipDiv_One.show();
		tipDiv_Another.show();
	}
	else
	{
		tipDiv_One.hide();
		tipDiv_Another.hide();
	}
	
	showSpeakerImage(speaker, downState, imageSwiperIndex);
}

function updateNikeName(speaker,imageSwiperIndex)
{	
	var speakerImageDiv_One = $('.speaker_image').eq(imageSwiperIndex);
	var speakerImageDiv_Another = getAnotherSpeakerImageDiv(imageSwiperIndex);
	
	var nicknameDiv_One = speakerImageDiv_One.children('.speaker_nickname');
	var nicknameDiv_Another = speakerImageDiv_Another.children('.speaker_nickname');
		
	if(speaker.name === mSpeakerSelectedName)
	{
		nicknameDiv_One.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'selected.png"/>');
		nicknameDiv_Another.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'selected.png"/>');
	}
	else
	{
		if(speaker.sex === WOMAN)
		{
			nicknameDiv_One.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'select_she.png" onClick="speakerSelect()"/>');
			nicknameDiv_Another.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'select_she.png" onClick="speakerSelect()"/>');
		}
		else
		{
			nicknameDiv_One.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'select_he.png" onClick="speakerSelect()"/>');
			nicknameDiv_Another.html(speaker.nickname+'<br/><img class="speaker_select" src="'+mImage_path+'select_he.png" onClick="speakerSelect()"/>');
		}
	}
}

// 根据下载状态调节图片显示情况和位置大小
function showSpeakerImage(speaker, downState, imageSwiperIndex)
{
	var speakerImageDiv_One = $('.speaker_image').eq(imageSwiperIndex);
	var speakerImageDiv_Another = getAnotherSpeakerImageDiv(imageSwiperIndex);

	var progressDiv_One = speakerImageDiv_One.children('.progressBar');
	var grayImg_One = progressDiv_One.children('.speaker_img_no_down');
	var brightImg_One = speakerImageDiv_One.children('.speaker_img_downed');
	
	var progressDiv_Another = speakerImageDiv_Another.children('.progressBar');
	var grayImg_Another = progressDiv_Another.children('.speaker_img_no_down');
	var brightImg_Another = speakerImageDiv_Another.children('.speaker_img_downed');
	
	// 还没下载
	if (downState === NOT_DOWN)
	{	
		brightImg_One.hide();
		brightImg_Another.hide();
		showImageGray(speaker, imageSwiperIndex, progressDiv_One, progressDiv_Another, grayImg_One, grayImg_Another);	
	}
	// 正在下载
	else if(downState === DOWNING)
	{
		showImageBright(speaker, imageSwiperIndex, brightImg_One, brightImg_Another);
		showImageGray(speaker, imageSwiperIndex, progressDiv_One, progressDiv_Another, grayImg_One, grayImg_Another);
		
		setProgress(speaker, imageSwiperIndex);
	}
	else if(downState === HAS_DOWN)
	{
		progressDiv_One.hide();
		progressDiv_Another.hide();
		showImageBright(speaker, imageSwiperIndex, brightImg_One, brightImg_Another);
	}

}

// 显示鲜艳的发音人图片
function showImageBright(speaker, imageSwiperIndex, brightImg_One, brightImg_Another)
{
	var src_path;
	// assest 版本
	if(speaker.name === SPEAKER_XIAOYAN)
	{
		src_path = mImage_path_prefix+speaker.image_bright_name;
	}
	else
	{
		src_path = HTTP_PREFIX+mImage_path_prefix+speaker.image_bright_name;
	}
    // 上线版本
	//src_path = mImage_path_prefix+speaker.image_bright_name;
	
	var img_one_src = brightImg_One.attr('src');
	var img_another_src = brightImg_Another.attr('src');
	//consoleLog("showImageBright: src_path="+src_path+" brightImg_One src="+img_one_src);
	if(img_one_src != undefined && img_one_src.indexOf(src_path) >= 0 && img_another_src != undefined && img_another_src.indexOf(src_path) >= 0)
	{
		// 图片已经设置
		consoleLog("showImageBright: not need refresh");
		brightImg_One.css('margin-left',($('.speaker_image').width() - brightImg_One.width())/2);
		brightImg_Another.css('margin-left',($('.speaker_image').width() - brightImg_Another.width())/2);
		brightImg_One.show();
		brightImg_Another.show();
		return;
	}
	
	brightImg_One.hide();
	brightImg_Another.hide();
	
	var image = new Image();
	image.src = src_path;
	$(image).load(function()
	{
		if(isSpeakerInThePosition(speaker.name, imageSwiperIndex))
		{
			consoleLog("showImageBright: refreshing ");
			// 调整图片的位置、大小			
			var rate = getPictureRate(RESOLUTION_720);
			var width = image.width * rate;
			brightImg_One.width(width);
			brightImg_Another.width(width);
			brightImg_One.css('margin-left',($('.speaker_image').width() - brightImg_One.width())/2);
			brightImg_Another.css('margin-left',($('.speaker_image').width() - brightImg_Another.width())/2);
			
			brightImg_One.attr('src',image.src);
			brightImg_Another.attr('src',image.src);
			
			brightImg_One.show();
			brightImg_Another.show();
		}
	});
}

// 显示灰度的发音人图片
function showImageGray(speaker, imageSwiperIndex, progressDiv_One, progressDiv_Another, grayImg_One, grayImg_Another)
{
	var src_path;
	// assest 版本
	if(speaker.name === SPEAKER_XIAOYAN)
	{
		src_path = mImage_path_prefix+speaker.image_gray_name;
	}
	else
	{
		src_path = HTTP_PREFIX+mImage_path_prefix+speaker.image_gray_name;
	}
    // 上线版本
	//src_path = mImage_path_prefix+speaker.image_gray_name;
	
	var img_one_src = grayImg_One.attr('src');
	var img_another_src = grayImg_Another.attr('src');
	//consoleLog("showImageGray: src_path="+src_path+" grayImg_One src="+img_one_src);
	if(img_one_src != undefined && img_one_src.indexOf(src_path) >= 0 && img_another_src != undefined && img_another_src.indexOf(src_path) >= 0)
	{
		// 图片已经设置
		consoleLog("showImageGray: not need refresh");
		progressDiv_One.css('margin-left',($('.speaker_image').width() - progressDiv_One.width())/2);
		progressDiv_Another.css('margin-left',($('.speaker_image').width() - progressDiv_Another.width())/2);
		progressDiv_One.show();
		progressDiv_Another.show();
		return;
	}
	
	progressDiv_One.hide();
	progressDiv_Another.hide();

    var image = new Image();
	image.src = src_path;
	$(image).load(function()
	{

		// 调整图片的位置、大小			
		var rate = getPictureRate(RESOLUTION_720);
		var width = image.width * rate;
		var height = image.height * rate;
		if(isSpeakerInThePosition(speaker.name, imageSwiperIndex))
		{
			consoleLog("showImageGray: refreshing");
			grayImg_One.width(width);
			grayImg_Another.width(width);
			
			progressDiv_One.width(width);
			progressDiv_Another.width(width);
			progressDiv_One.height(height);
			progressDiv_Another.height(height);
			
			progressDiv_One.css('margin-left',($('.speaker_image').width() - progressDiv_One.width())/2);
			progressDiv_Another.css('margin-left',($('.speaker_image').width() - progressDiv_Another.width())/2);
			
			grayImg_One.attr('src',image.src);
			grayImg_Another.attr('src',image.src);
			
			progressDiv_One.show();
			progressDiv_Another.show();
		}
		
		speaker.image_height = height;
	});
}

// 根据图片制作时参照的分辨率获取准确的的压缩比
function getPictureRate(resolution)
{
	return mScreenWidth / resolution / mDensity;
}

/**
设置下载进度,并处理进度条的显示隐藏状态
speecherName  正在下载的发音人的name
progress      下载进度，0-1
**/
function setProgress(speaker, imageSwiperIndex)
{
	// 和当前显示的发音人名字不等，则不更新进度
	if(speaker.name !== getSpeakerNameByIndex(mCurSpeakerIndex))
	{
		return;
	}
	
	if(mProgressBarHeight === 0)
	{
		mProgressBarHeight = speaker.image_height;
	}
	// 只在进度条高度能获取到的情况下才显示下载进度
	if(mProgressBarHeight !== 0)
	{	
		var speakerImageDiv_One = $('.speaker_image').eq(imageSwiperIndex);
		var speakerImageDiv_Another = getAnotherSpeakerImageDiv(imageSwiperIndex);
			
		var progressDiv_One = speakerImageDiv_One.children('.progressBar');
		var progressDiv_Another = speakerImageDiv_Another.children('.progressBar');
		
		var heightRate = 1 - mDownProgress;
		if(heightRate < 0.001)
		{
			progressDiv_One.hide();
			progressDiv_Another.hide();
		}
		else
		{
			progressDiv_One.show();
			progressDiv_Another.show();
		}
	
		if(progressDiv_One.is(':visible'))
		{
			progressDiv_One.height(mProgressBarHeight * heightRate);
			progressDiv_Another.height(mProgressBarHeight * heightRate);
		}	
	}
}

function resetOpacity(oldIndex,newIndex)
{
	var oldAntherIndex = getAnotherIndex(mSpeakerCount,SLIDES_PERVIEW,oldIndex);
	var newAnotherIndex = getAnotherIndex(mSpeakerCount,SLIDES_PERVIEW,newIndex);
	
	// 显示旧的滑块的半透明图层
	var opacityLayerDiv = $('.speaker_icon').eq(oldIndex).children('.opacity_layer');
	opacityLayerDiv.css('background-color','#000000');
	opacityLayerDiv.css('filter','alpha(Opacity=30)');
	opacityLayerDiv.css('-moz-opacity','0.3');
	opacityLayerDiv.css('opacity','0.3');
	if(oldAntherIndex !== oldIndex)
	{
		opacityLayerDiv = $('.speaker_icon').eq(oldAntherIndex).children('.opacity_layer');
		opacityLayerDiv.css('background-color','#000000');
		opacityLayerDiv.css('filter','alpha(Opacity=30)');
		opacityLayerDiv.css('-moz-opacity','0.3');
		opacityLayerDiv.css('opacity','0.3');
	}
	
	// 隐藏当前中间滑块的半透明图层
	opacityLayerDiv = $('.speaker_icon').eq(newIndex).children('.opacity_layer');
	opacityLayerDiv.css('background-color','');
	opacityLayerDiv.css('filter','alpha(Opacity=0)');
	opacityLayerDiv.css('-moz-opacity','0');
	opacityLayerDiv.css('opacity','0');
	if(newAnotherIndex !== newIndex)
	{
		opacityLayerDiv = $('.speaker_icon').eq(newAnotherIndex).children('.opacity_layer');
		opacityLayerDiv.css('background-color','');
		opacityLayerDiv.css('filter','alpha(Opacity=0)');
		opacityLayerDiv.css('-moz-opacity','0');
		opacityLayerDiv.css('opacity','0');
	}
}

// 更新下载按钮状态
function updateDownLoadButtonState()
{
	consoleLog("updateDownLoadButtonState: mCurDownState="+mCurDownState);
	
	var width;
	var height;
	if(mCurDownState === HAS_DOWN)
	{		
		$('.download_button').show();
		$('.rotate_button').hide();
		$('.progress_value').hide();
		
		$('.download_button').attr('src',mImage_path + 'speaker_share.png');
		
		width = 56 * getPictureRate(RESOLUTION_480);
		height = 56 * getPictureRate(RESOLUTION_480);
		$('.download_button').width(width);
		$('.download_button').height(height);
		$('.download_button').css('margin-top',($('.download_layout').height() - $('.download_button').height())/2);
		$('.download_button').css('margin-left',($('.download_layout').width() - $('.download_button').width())/2);	
	}
	else if(mCurDownState === NOT_DOWN)
	{	
		$('.download_button').show();
		$('.rotate_button').hide();
		$('.progress_value').hide();
		
		$('.download_button').attr('src',mImage_path + 'download_speaker.png');
				
		width = 47 * getPictureRate(RESOLUTION_480);
		height = 47 * getPictureRate(RESOLUTION_480);
		$('.download_button').width(width);
		$('.download_button').height(height);
		$('.download_button').css('margin-top',($('.download_layout').height() - $('.download_button').height())/2);
		$('.download_button').css('margin-left',($('.download_layout').width() - $('.download_button').width())/2);	
	}
	else
	{		
		$('.download_button').hide();
		$('.rotate_button').show();
		$('.progress_value').show();
		
		showProgressValue();
	}
}

function showProgressValue()
{
	$('.progress_value').text(parseInt(mDownProgress * 100) + "%");
	$('.progress_value').css('margin-top',($('.download_layout').height() - $('.progress_value').height())/2);
	$('.progress_value').css('margin-left',($('.download_layout').width() - $('.progress_value').width())/2);
}

// 根据当前发音人来判断name对应的发音人是否在正确的位置
function isSpeakerInThePosition(name, imageSwiperIndex)
{
	consoleLog("isSpeakerInThePosition: name="+name+" imageSwiperIndex="+imageSwiperIndex);
	// 副本所在位置
	var anotherImageSwiperIndex = getAnotherIndex(3,1,imageSwiperIndex);
	
	// 获取当前mImageSwiper的活动项的下标
	var imageSwiperActiveIndex = mImageSwiper.activeIndex;
	// 获取当前mImageSwiper的活动项的左边项的下标
	var leftImageSwiperIndex = mImageIndexArray[imageSwiperActiveIndex][0];
	// 获取当前mImageSwiper的活动项的右边项的下标
	var rightImageSwiperIndex = mImageIndexArray[imageSwiperActiveIndex][1];
	
	var speakerName;
	// 前一个
	if(imageSwiperIndex === leftImageSwiperIndex || anotherImageSwiperIndex === leftImageSwiperIndex)
	{
		speakerName = getSpeakerNameByIndex(mCurSpeakerIndex - 1);
	}
	else if(imageSwiperIndex === imageSwiperActiveIndex || anotherImageSwiperIndex === imageSwiperActiveIndex)
	{
		speakerName = getSpeakerNameByIndex(mCurSpeakerIndex);
	}
	// 后一个
	else if(imageSwiperIndex === rightImageSwiperIndex || anotherImageSwiperIndex === rightImageSwiperIndex)
	{
		speakerName = getSpeakerNameByIndex(mCurSpeakerIndex + 1);
	}
	
	return (name === speakerName)? true:false;
}

// 根据发音人名字获取对应的大图在mImageSwiper里的位置
function getImageSwiperIndexByName(speakerName)
{
	var count = mImageSwiper.slides.length;
	if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex - 1))
	{
		return (mImageSwiper.activeIndex - 1 + count) % count;
	}
	else if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex))
	{
		return mImageSwiper.activeIndex;
	}
	else if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex + 1))
	{
		return (mImageSwiper.activeIndex + 1) % count;
	}
	
	return -1;
	
}





/**** 以下是要回调给客户端的接口 ****/

// 要传给客户端的接口的参数key
var TAG_NAME = "name";
var TAG_NICK_NAME = "nickname";
var TAG_ID = "id";
var TAG_SEX = "sex";
var TAG_AGE = "age";
var TAG_ACCENT = "accent";
var TAG_LANGUAGE = "language";
var TAG_VERCODE = "vercode";

var TAG_TTSRESOURCEID = "ttsResourceId";
var TAG_LISTENRESOURCEID = "listenResourceId";
var TAG_TTSTEXT = "tts_text";

var LOG_KEY = "event_id";
	
// 发音人下载按钮被点击
function downLoadClick(){	
	consoleLog("downLoadClick: mCurDownState="+mCurDownState);
	
	var speaker = getSpeakerByIndex(mCurSpeakerIndex);
	
	// 回调给客户端
	if(mCurDownState === HAS_DOWN)
	{
		// 发音人分享
		var params = TAG_NAME+"="+speaker.name+","+TAG_NICK_NAME+"="+speaker.nickname+","+TAG_TTSTEXT+"="+speaker.tts_text;
	    JSHandler.JSCall(JS_CALL_SPEAKER_SHARE,params);		
	}
	else
	{
		var params = TAG_NAME+"="+speaker.name+","+TAG_NICK_NAME+"="+speaker.nickname+","
		             +TAG_ID+"="+speaker.id+","+TAG_SEX+"="+speaker.sex+","
					 +TAG_AGE+"="+speaker.age+","+TAG_ACCENT+"="+speaker.accent+","
					 +TAG_LANGUAGE+"="+speaker.language+","+TAG_VERCODE+"="+speaker.vercode+","
		             +TAG_TTSRESOURCEID+"="+speaker.ttsResourceId;
	    JSHandler.JSCall(JS_CALL_SPEAKER_DOWN,params);		
	}
}

function speakerSee()
{
	consoleLog("speakerSee:");
	
	var speaker = getSpeakerByIndex(mCurSpeakerIndex);
	var params = TAG_NAME+"="+speaker.name+","+TAG_NICK_NAME+"="+speaker.nickname+","+TAG_TTSTEXT+"="+speaker.tts_text;
	JSHandler.JSCall(JS_CALL_SPEAKER_SEE,params);	
}
// 试听按钮被点击
function listenClick(){
	consoleLog("listenClick:");
	
	$('.listen_button').attr('src',mImage_path + 'tts_play_p.png');
	
	var speaker = getSpeakerByIndex(mCurSpeakerIndex);
    var params = TAG_NAME+"="+speaker.name+","+TAG_LISTENRESOURCEID+"="+speaker.listenResourceId
	             +","+TAG_TTSTEXT+"="+speaker.tts_text+","+LOG_KEY+"="+(speaker.name + "_listen");
	JSHandler.JSCall(JS_CALL_SPEAKER_LISTENING,params);
}

// 选择发音人
function speakerSelect(){
	var speaker = getSpeakerByIndex(mCurSpeakerIndex);
	
	// 已经下载，并且当前选择的发音人不是当前显示的这个
	if(mSpeakerSelectedName !== speaker.name)
	{
		var oldSpeakerSelectedName = mSpeakerSelectedName;
		
		var params = TAG_NAME+"="+speaker.name;
	    mSpeakerSelectedName = JSHandler.JSCall(JS_CALL_SPEAKER_SELECT,params);
		
		consoleLog("oldSpeakerSelectedName="+oldSpeakerSelectedName+" mSpeakerSelectedName="+mSpeakerSelectedName+" speaker.name="+speaker.name);
		if(mSpeakerSelectedName === speaker.name)
		{
			// 把之前选择的发音人状态先去掉
			var imageSwiperIndex = getImageSwiperIndexByName(oldSpeakerSelectedName);	
			if(imageSwiperIndex !== -1)
			{
				updateNikeName(getSpeakerByName(oldSpeakerSelectedName),imageSwiperIndex);
			}
			
			// 把当前选择的发音人状态改变
			imageSwiperIndex = getImageSwiperIndexByName(mSpeakerSelectedName);	
			if(imageSwiperIndex !== -1)
			{
				updateNikeName(speaker,imageSwiperIndex);
			}
		}
	}
}







/**** 以下是由客户端回调的接口 ****/

// 试听结束回调
function listenEnd(speakerName){
	consoleLog("listenEnd:"+speakerName);
	
	$('.listen_button').attr('src',mImage_path + 'tts_play.png');
}

// 开始下载发音人资源
function downLoadStart(speakerName)
{
	consoleLog("downLoadStart:"+speakerName);
	
	mDownProgress = 0;
	
	// 初始化进度条高度
	var speaker = getSpeakerByName(speakerName);
	if(!speaker)
	{
		mProgressBarHeight = 0;
	}
	else
	{
		mProgressBarHeight = speaker.image_height;
	}
	
	if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex))
	{
			
		mCurDownState = DOWNING;
		// 人物图片不处于滑动状态
		if(!isImageSwiperMove)
		{
			updateDownLoadButtonState();
			
			var imageSwiperIndex = getImageSwiperIndexByName(speakerName);	
			if(imageSwiperIndex !== -1)
			{
				showSpeakerImage(speaker, DOWNING, imageSwiperIndex);
			}
		}
	}
}

// 下载进度回调
function downLoadProgress(speakerName, progress){
	consoleLog("downLoadProgress: speakerName="+speakerName+" progress="+progress);
	
	// 更新下载进度		
	mDownProgress = parseFloat(progress);
	if(mDownProgress < 0)
		mDownProgress = 0;
	else if(mDownProgress > 1)
		mDownProgress = 1;
		
	
	// 人物图片不处于滑动状态
	if(!isImageSwiperMove && speakerName === getSpeakerNameByIndex(mCurSpeakerIndex))
	{
		// 更新下载进度值
		showProgressValue();
		
		var imageSwiperIndex = getImageSwiperIndexByName(speakerName);	
		if(imageSwiperIndex !== -1)
		{
			setProgress(getSpeakerByName(speakerName), imageSwiperIndex);
		}
	}
}

// 下载成功回调
function downLoadSuccess(speakerName){
	consoleLog("downLoadSuccess: speakerName="+speakerName);
	
	mDownProgress = 1;
	
	if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex))
	{
			
		mCurDownState = HAS_DOWN;
		// 人物图片不处于滑动状态
		if(!isImageSwiperMove)
		{
			// 更新下载按钮状态
			updateDownLoadButtonState();
	
			var imageSwiperIndex = getImageSwiperIndexByName(speakerName);	
			if(imageSwiperIndex !== -1)
			{
				setProgress(getSpeakerByName(speakerName), imageSwiperIndex);
			}
		}
	}
}

// 下载失败回调
function downLoadFail(speakerName){
	consoleLog("downLoadFail: speakerName="+speakerName);
	
	mDownProgress = 0;
	
	if(speakerName === getSpeakerNameByIndex(mCurSpeakerIndex))
	{	
		mCurDownState = NOT_DOWN;
		// 人物图片不处于滑动状态
		if(!isImageSwiperMove)
		{
			// 更新下载按钮状态
			updateDownLoadButtonState();
			
			var imageSwiperIndex = getImageSwiperIndexByName(speakerName);	
			if(imageSwiperIndex !== -1)
			{
				setProgress(getSpeakerByName(speakerName), imageSwiperIndex);
			}
		}
	}
}
